Evaluations
Create Evaluation
Beta. Usable today, but this endpoint can change before it is stable, without a new Kite-Version. Changes are announced before they ship.
Run an SDK spec on Kite. The spec is checked first (the same checks as /v1/evaluations/validate), so a spec
that cannot run is refused here, for free. Returns 202 with a queued run; poll GET /v1/evaluations/, or
subscribe to evaluation.succeeded / evaluation.failed / evaluation.canceled. Send an Idempotency-Key to make retries safe: a retry
with the same key and body returns the same run, even while the first request is still in flight.
POST
/
v1
/
evaluations
Create Evaluation
curl --request POST \
--url https://api.kiteml.com/v1/evaluations \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"files": {
"../evals": {
"kind": "directory",
"shipped": "evals"
}
},
"spec_path": "specs/smoke.yaml",
"spec_yaml": "kite_spec_version: \"2\"\nname: smoke\npolicy: {kind: scripted_pick, ref: scripted_pick}\n..."
}
'import requests
url = "https://api.kiteml.com/v1/evaluations"
payload = {
"files": { "../evals": {
"kind": "directory",
"shipped": "evals"
} },
"spec_path": "specs/smoke.yaml",
"spec_yaml": "kite_spec_version: \"2\"
name: smoke
policy: {kind: scripted_pick, ref: scripted_pick}
..."
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
files: {'../evals': {kind: 'directory', shipped: 'evals'}},
spec_path: 'specs/smoke.yaml',
spec_yaml: 'kite_spec_version: "2"\nname: smoke\npolicy: {kind: scripted_pick, ref: scripted_pick}\n...'
})
};
fetch('https://api.kiteml.com/v1/evaluations', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.kiteml.com/v1/evaluations",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'files' => [
'../evals' => [
'kind' => 'directory',
'shipped' => 'evals'
]
],
'spec_path' => 'specs/smoke.yaml',
'spec_yaml' => 'kite_spec_version: "2"
name: smoke
policy: {kind: scripted_pick, ref: scripted_pick}
...'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.kiteml.com/v1/evaluations"
payload := strings.NewReader("{\n \"files\": {\n \"../evals\": {\n \"kind\": \"directory\",\n \"shipped\": \"evals\"\n }\n },\n \"spec_path\": \"specs/smoke.yaml\",\n \"spec_yaml\": \"kite_spec_version: \\\"2\\\"\\nname: smoke\\npolicy: {kind: scripted_pick, ref: scripted_pick}\\n...\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.kiteml.com/v1/evaluations")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"files\": {\n \"../evals\": {\n \"kind\": \"directory\",\n \"shipped\": \"evals\"\n }\n },\n \"spec_path\": \"specs/smoke.yaml\",\n \"spec_yaml\": \"kite_spec_version: \\\"2\\\"\\nname: smoke\\npolicy: {kind: scripted_pick, ref: scripted_pick}\\n...\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.kiteml.com/v1/evaluations")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"files\": {\n \"../evals\": {\n \"kind\": \"directory\",\n \"shipped\": \"evals\"\n }\n },\n \"spec_path\": \"specs/smoke.yaml\",\n \"spec_yaml\": \"kite_spec_version: \\\"2\\\"\\nname: smoke\\npolicy: {kind: scripted_pick, ref: scripted_pick}\\n...\"\n}"
response = http.request(request)
puts response.read_body{
"id": "<string>",
"status": "queued",
"progress": 0.5,
"tokens": {
"charged": 123,
"refunded": 123
},
"object": "evaluation",
"phase": "<string>",
"status_message": "<string>",
"episodes": {
"done": 123,
"total": 123
},
"error": {
"code": "<string>",
"message": "<string>",
"resumable": true,
"param": "<string>",
"details": {}
},
"spec": {},
"kite_version": "<string>",
"options": {},
"label": "<string>",
"result": {
"verified": true,
"run_id": "<string>",
"manifest_hash": "<string>",
"run_hash": "<string>",
"determinism_verified": true,
"metrics": [
{
"id": "<string>",
"version": "<string>",
"value": 123,
"interval": [
123
],
"n": 123
}
]
},
"download": {
"url": "<string>",
"requires_auth": true,
"filename": "<string>",
"bytes": 123,
"sha256": "<string>",
"expires_at": "<string>"
},
"webhook_metadata": {},
"created_at": "<string>",
"started_at": "<string>",
"completed_at": "<string>",
"links": {}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}Authorizations
Headers
Body
application/json
Run a spec. spec_yaml and the files it names are required; everything else has a default.
Response
The run, queued
One run of an SDK spec.
⌘I
Create Evaluation
curl --request POST \
--url https://api.kiteml.com/v1/evaluations \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"files": {
"../evals": {
"kind": "directory",
"shipped": "evals"
}
},
"spec_path": "specs/smoke.yaml",
"spec_yaml": "kite_spec_version: \"2\"\nname: smoke\npolicy: {kind: scripted_pick, ref: scripted_pick}\n..."
}
'import requests
url = "https://api.kiteml.com/v1/evaluations"
payload = {
"files": { "../evals": {
"kind": "directory",
"shipped": "evals"
} },
"spec_path": "specs/smoke.yaml",
"spec_yaml": "kite_spec_version: \"2\"
name: smoke
policy: {kind: scripted_pick, ref: scripted_pick}
..."
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
files: {'../evals': {kind: 'directory', shipped: 'evals'}},
spec_path: 'specs/smoke.yaml',
spec_yaml: 'kite_spec_version: "2"\nname: smoke\npolicy: {kind: scripted_pick, ref: scripted_pick}\n...'
})
};
fetch('https://api.kiteml.com/v1/evaluations', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.kiteml.com/v1/evaluations",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'files' => [
'../evals' => [
'kind' => 'directory',
'shipped' => 'evals'
]
],
'spec_path' => 'specs/smoke.yaml',
'spec_yaml' => 'kite_spec_version: "2"
name: smoke
policy: {kind: scripted_pick, ref: scripted_pick}
...'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.kiteml.com/v1/evaluations"
payload := strings.NewReader("{\n \"files\": {\n \"../evals\": {\n \"kind\": \"directory\",\n \"shipped\": \"evals\"\n }\n },\n \"spec_path\": \"specs/smoke.yaml\",\n \"spec_yaml\": \"kite_spec_version: \\\"2\\\"\\nname: smoke\\npolicy: {kind: scripted_pick, ref: scripted_pick}\\n...\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.kiteml.com/v1/evaluations")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"files\": {\n \"../evals\": {\n \"kind\": \"directory\",\n \"shipped\": \"evals\"\n }\n },\n \"spec_path\": \"specs/smoke.yaml\",\n \"spec_yaml\": \"kite_spec_version: \\\"2\\\"\\nname: smoke\\npolicy: {kind: scripted_pick, ref: scripted_pick}\\n...\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.kiteml.com/v1/evaluations")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"files\": {\n \"../evals\": {\n \"kind\": \"directory\",\n \"shipped\": \"evals\"\n }\n },\n \"spec_path\": \"specs/smoke.yaml\",\n \"spec_yaml\": \"kite_spec_version: \\\"2\\\"\\nname: smoke\\npolicy: {kind: scripted_pick, ref: scripted_pick}\\n...\"\n}"
response = http.request(request)
puts response.read_body{
"id": "<string>",
"status": "queued",
"progress": 0.5,
"tokens": {
"charged": 123,
"refunded": 123
},
"object": "evaluation",
"phase": "<string>",
"status_message": "<string>",
"episodes": {
"done": 123,
"total": 123
},
"error": {
"code": "<string>",
"message": "<string>",
"resumable": true,
"param": "<string>",
"details": {}
},
"spec": {},
"kite_version": "<string>",
"options": {},
"label": "<string>",
"result": {
"verified": true,
"run_id": "<string>",
"manifest_hash": "<string>",
"run_hash": "<string>",
"determinism_verified": true,
"metrics": [
{
"id": "<string>",
"version": "<string>",
"value": 123,
"interval": [
123
],
"n": 123
}
]
},
"download": {
"url": "<string>",
"requires_auth": true,
"filename": "<string>",
"bytes": 123,
"sha256": "<string>",
"expires_at": "<string>"
},
"webhook_metadata": {},
"created_at": "<string>",
"started_at": "<string>",
"completed_at": "<string>",
"links": {}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}